"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSubject = exports.useObservableState = exports.useObservable = void 0;
var react_1 = require("react");
/**
 * Subscribe to Observable
 */
function useObservable(obs$, setState) {
    react_1.useEffect(function () {
        if (!obs$) {
            return;
        }
        var sub = obs$.subscribe(function (state) {
            setState(state);
        });
        return function () {
            sub.unsubscribe();
        };
    }, [obs$, setState]);
}
exports.useObservable = useObservable;
function useObservableState(obs$, initialState) {
    if (initialState === void 0) { initialState = null; }
    var _a = react_1.useState(initialState), state = _a[0], setState = _a[1];
    useObservable(obs$, setState);
    return state;
}
exports.useObservableState = useObservableState;
/**
 * Subscribe to BehaviorSubject
 */
function useSubject(sub$) {
    var _a;
    return useObservableState(sub$, (_a = sub$ === null || sub$ === void 0 ? void 0 : sub$.value) !== null && _a !== void 0 ? _a : null);
}
exports.useSubject = useSubject;
//# sourceMappingURL=useObservable.js.map