"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStoreState = exports.useStore = void 0;
var react_1 = require("react");
var ProstoreContext_1 = require("./ProstoreContext");
var useConnectStore_1 = require("./useConnectStore");
/**
 * Subscribe component to the store
 *
 * @param storeOrName - Store instance or name for it to be injected from the context
 * @returns
 *  state - local copy of store state;
 *  store - instance of the store
 */
function useStore(storeOrName) {
    var store = ProstoreContext_1.useContextStore(storeOrName);
    var _a = react_1.useState(store.state), state = _a[0], setState = _a[1];
    useConnectStore_1.useConnectStore(store, setState);
    return [state, store];
}
exports.useStore = useStore;
/**
 * Subscribe component to the store
 *
 * @param storeOrName - Store instance or name for it to be injected from the context
 * @returns local copy of store state
 */
function useStoreState(storeOrName) {
    var store = ProstoreContext_1.useContextStore(storeOrName);
    var _a = react_1.useState(store.state), state = _a[0], setState = _a[1];
    useConnectStore_1.useConnectStore(store, setState);
    return state;
}
exports.useStoreState = useStoreState;
//# sourceMappingURL=useStore.js.map